// 定数
int MASU_S = 32; // マス目の大きさ（ピクセル）
int MEIRO_X = 16; // 迷路の横サイズ
int MEIRO_Y = 12; // 迷路の縦サイズ
int WALKED = 99;
// 迷路の設定 1＝壁
int[][] meiro = 
{{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
 {1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1},
 {1,0,1,0,1,1,1,0,1,1,1,0,1,1,0,1},
 {1,0,1,0,0,0,0,0,0,0,1,0,1,0,0,1},
 {1,0,1,0,1,0,1,1,1,1,1,0,1,0,1,1},
 {1,0,1,0,1,1,1,0,0,0,0,0,1,0,0,1},
 {1,0,0,0,1,0,0,0,0,1,0,0,1,1,0,1},
 {1,0,1,0,1,1,1,1,0,1,1,1,1,0,0,1},
 {1,0,1,0,0,0,0,0,0,0,0,1,0,0,0,1},
 {1,0,1,1,0,1,1,0,1,1,0,1,0,0,0,1},
 {1,0,0,0,0,0,1,0,0,1,0,0,0,0,0,1}, 
 {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}};
// 変数
int genzai_x, genzai_y; // 現在地を表す
int start_x, start_y; // スタート地点を表す
int goal_x, goal_y; // ゴールを表す
int isGoal = 0; // ゴールしたかどうか？を表すフラグ
int stack_top; // スタックの頂点
// 配列変数
int[] hai_x = new int[1024];
int[] hai_y = new int[1024];
// データをスタックに入れる関数
void stack_push(){
  hai_x[stack_top] = genzai_x;
  hai_y[stack_top] = genzai_y;
  stack_top++; 
}
// データをスタックから取り出して
// genzai_xとgenzai_yに代入する関数
void stack_pop(){
  stack_top--;
  genzai_x = hai_x[stack_top];
  genzai_y = hai_y[stack_top];
} 
// 初期化を記述するセットアップ関数
void setup(){
  // ウィンドウの大きさを設定
  size(MEIRO_X * MASU_S, MEIRO_Y * MASU_S); 
  start_x = 1; // スタート地点の設定
  start_y = 1; // スタート地点の設定
  goal_x = 13; // ゴールの設定
  goal_y = 9; // ゴールの設定
  genzai_x = start_x; // 現在地をスタート地点に設定
  genzai_y = start_y; // 現在地をスタート地点に設定
}
// 迷路を描く関数
void meiro_egaku(){
  background(192);
  for(int y=0; y<MEIRO_Y; y++){
    for(int x=0; x<MEIRO_X; x++){
      if(meiro[y][x] == 1){ // 壁を描く     
        fill(157, 187, 97); // 淡い緑
        rect(x * MASU_S, y * MASU_S, MASU_S, MASU_S);
      }
      if(meiro[y][x] == WALKED){ // 足跡を描く 
        fill(84, 109, 142); // 薄い紺 
        rect(x * MASU_S, y * MASU_S, MASU_S, MASU_S);
      }
      // スタートを描く
      fill(0, 0, 255); // 青 
      rect(start_x*MASU_S, start_y*MASU_S, MASU_S, MASU_S);
      // ゴールを描く
      fill(255, 255, 0); // 黄 
      rect(goal_x*MASU_S, goal_y*MASU_S, MASU_S, MASU_S);
      // 現在地を描く
      fill(255, 126, 0); // オレンジ
      rect(genzai_x*MASU_S, genzai_y*MASU_S, MASU_S, MASU_S);      
    }
  }
}
// 足跡を付けながらゴールを探す関数
int AshiatoWalk(){
  int x = genzai_x;
  int y = genzai_y;
  // ゴールを発見したかどうかをチェック
  if(x == goal_x && y == goal_y){
    isGoal = 1;
    return 2;
  }
  // 上
  if(meiro[y-1][x] == 0){
    stack_push();
    genzai_y = y - 1; // 歩く
    meiro[y][x] = WALKED;
    return 1;
  }
  // 下
  if(meiro[y+1][x] == 0){
    stack_push();
    genzai_y = y + 1; // 歩く
    meiro[y][x] = WALKED;
    return 1;
  }
  // 左
  if(meiro[y][x-1] == 0){
    stack_push();
    genzai_x = x - 1; // 歩く
    meiro[y][x] = WALKED;
    return 1;
  }
  // 右
  if(meiro[y][x+1] == 0){
    stack_push();
    genzai_x = x + 1; // 歩く
    meiro[y][x] = WALKED;
    return 1;
  }
  meiro[y][x] = WALKED;
  // ここに来るということは行き止まりなので
  // 1歩戻る
  stack_pop();
  print("BACK ! ");
  return 0;
}

void mouseDragged(){
  if(isGoal == 1){
    // ゴールしたときの処理 
    print("GOAL !\n");
  }else{
    // ゴールしていなければ探索
    AshiatoWalk();
  }
}
// 描画関数 標準では1秒間に60回実行される
void draw(){
  meiro_egaku();
}
