// 定数
int MASU_S = 32; // マス目の大きさ（ピクセル）
int MEIRO_X = 16; // 迷路の横サイズ
int MEIRO_Y = 12; // 迷路の縦サイズ
int WALKED = 99;
int ROUTE = 999;
// 迷路の設定 1＝壁
int[][] meiro = 
{{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
 {1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1},
 {1,0,1,0,1,1,1,0,1,1,1,0,1,1,0,1},
 {1,0,1,0,0,0,0,0,0,0,1,0,1,0,0,1},
 {1,0,1,0,1,0,1,1,1,1,1,0,1,0,1,1},
 {1,0,1,0,1,1,1,0,0,0,0,0,1,0,0,1},
 {1,0,0,0,1,0,0,0,0,1,0,0,1,1,0,1},
 {1,0,1,0,1,1,1,1,0,1,1,1,1,0,0,1},
 {1,0,1,0,0,0,0,0,0,0,0,1,0,0,0,1},
 {1,0,1,1,0,1,1,0,1,1,0,1,0,0,0,1},
 {1,0,0,0,0,0,1,0,0,1,0,0,0,0,0,1}, 
 {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}};
// 変数
int genzai_x, genzai_y; // 現在地を表す
int start_x, start_y; // スタート地点を表す
int goal_x, goal_y; // ゴールを表す
int isGoal = 0; // ゴールしたかどうか？を表すフラグ
int q_first = 0, q_last = 0; // キューの先頭と末尾
// 配列変数
int[] hai_x = new int[1024];
int[] hai_y = new int[1024];
// ルートを記録する配列
int[][] route_x = new int[MEIRO_Y][MEIRO_X];
int[][] route_y = new int[MEIRO_Y][MEIRO_X];

// データをキューに入れる関数
void en_q(int x, int y){
  hai_x[q_first] = x;
  hai_y[q_first] = y;
  q_first++; 
}
// データをキューから取り出して
// genzai_xとgenzai_yに代入する関数
void de_q(){
  genzai_x = hai_x[q_last];
  genzai_y = hai_y[q_last];
  q_last++;
} 
// 初期化を記述するセットアップ関数
void setup(){
  // ウィンドウの大きさを設定
  size(MEIRO_X * MASU_S, MEIRO_Y * MASU_S);
  start_x = 1; // スタート地点の設定
  start_y = 1; // スタート地点の設定
  goal_x = 13; // ゴールの設定
  goal_y = 9; // ゴールの設定
  genzai_x = start_x; // 現在地をスタート地点に設定
  genzai_y = start_y; // 現在地をスタート地点に設定
  en_q(start_x, start_y); // スタート地点をキューに入れる
}
// 迷路を描く関数
void meiro_egaku(){
  background(192);
  for(int y=0; y<MEIRO_Y; y++){
    for(int x=0; x<MEIRO_X; x++){
      if(meiro[y][x] == 1){ // 壁を描く     
        fill(157, 187, 97); // 淡い緑
        rect(x * MASU_S, y * MASU_S, MASU_S, MASU_S);
      }
      if(meiro[y][x] == WALKED){ // 足跡を描く 
        fill(84, 109, 142); // 薄い紺 
        rect(x * MASU_S, y * MASU_S, MASU_S, MASU_S);
      }
      // スタートからゴールまでのルートを描く
      if(meiro[y][x] == ROUTE){ 
        fill(255, 0, 0); // 赤
        rect(x*MASU_S, y*MASU_S, MASU_S, MASU_S);
      }
      // スタートを描く
      fill(0, 0, 255); // 青 
      rect(start_x*MASU_S, start_y*MASU_S, MASU_S, MASU_S);
      // ゴールを描く
      fill(255, 255, 0); // 黄 
      rect(goal_x*MASU_S, goal_y*MASU_S, MASU_S, MASU_S);   
    }
  }
}
// 幅優先探索（Breadth First Search）でゴールを探す関数
int BFS(){
  de_q();
  int x = genzai_x;
  int y = genzai_y;
  // ゴールを発見したかどうかをチェック
  if(x == goal_x && y == goal_y){
    isGoal = 1;
    return 2;
  }
  // 上
  if(meiro[y-1][x] == 0){
    route_x[y-1][x] = x;
    route_y[y-1][x] = y;
    en_q(x, y-1);
    meiro[y-1][x] = WALKED;
  }
  // 下
  if(meiro[y+1][x] == 0){
    route_x[y+1][x] = x;
    route_y[y+1][x] = y;
    en_q(x, y+1);
    meiro[y+1][x] = WALKED;
  }
  // 左
  if(meiro[y][x-1] == 0){
    route_x[y][x-1] = x;
    route_y[y][x-1] = y;
    en_q(x-1, y);
    meiro[y][x-1] = WALKED;
  }
  // 右
  if(meiro[y][x+1] == 0){
    route_x[y][x+1] = x;
    route_y[y][x+1] = y;
    en_q(x+1, y);
    meiro[y][x+1] = WALKED;
  }
  return 0;
}

void mouseDragged(){
  if(isGoal == 1){
    // ゴールしたときの処理
    print("GOAL !\n");
    int x1 = route_x[goal_y][goal_x];
    int y1 = route_y[goal_y][goal_x];
    int x2, y2;
    meiro[y1][x1] = ROUTE;
    do {
      x2 = route_x[y1][x1];
      y2 = route_y[y1][x1];
      meiro[y2][x2] = ROUTE;
      x1 = x2;
      y1 = y2;
    } while (!(route_x[y1][x1] == start_x 
               && route_y[y1][x1] == start_y));
  }else{
    // ゴールしていなければ探索
    BFS();
  }
}
// 描画関数 標準では1秒間に60回実行される
void draw(){
  meiro_egaku();
}
