// 定数
int MASU_S = 32; // マス目の大きさ（ピクセル）
int MEIRO_X = 16; // 迷路の横サイズ
int MEIRO_Y = 12; // 迷路の縦サイズ
// 迷路の設定 1＝壁
int[][] meiro = 
{{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
 {1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1},
 {1,0,1,0,1,1,1,0,1,1,1,0,1,1,0,1},
 {1,0,1,0,0,0,0,0,0,0,1,0,1,0,0,1},
 {1,0,1,0,1,0,1,1,1,1,1,0,1,0,1,1},
 {1,0,1,0,1,1,1,0,0,0,0,0,1,0,0,1},
 {1,0,0,0,1,0,0,0,0,1,0,0,1,1,0,1},
 {1,0,1,0,1,1,1,1,0,1,1,1,1,0,0,1},
 {1,0,1,0,0,0,0,0,0,0,0,1,0,0,0,1},
 {1,0,1,1,0,1,1,0,1,1,0,1,0,0,0,1},
 {1,0,0,0,0,0,1,0,0,1,0,0,0,0,0,1}, 
 {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}};
// 変数
int genzai_x, genzai_y; // 現在地を表す
int start_x, start_y; // スタート地点を表す
int goal_x, goal_y; // ゴールを表す
int isGoal = 0; // ゴールしたかどうか？を表すフラグ
int vx, vy; // 進行方向
// 初期化を記述するセットアップ関数
void setup(){
  // ウィンドウの大きさを設定
  size(MEIRO_X * MASU_S, MEIRO_Y * MASU_S);
  start_x = 1; // スタート地点の設定
  start_y = 1; // スタート地点の設定
  goal_x = 13; // ゴールの設定
  goal_y = 9; // ゴールの設定
  genzai_x = start_x; // 現在地をスタート地点に設定
  genzai_y = start_y; // 現在地をスタート地点に設定
  vx = 0;
  vy = 1;
}
// 迷路を描く関数
void meiro_egaku(){
  background(192);
  for(int y=0; y<MEIRO_Y; y++){
    for(int x=0; x<MEIRO_X; x++){
      if(meiro[y][x] == 1){ // 壁を描く     
        fill(157, 187, 97); // 淡い緑
        rect(x * MASU_S, y * MASU_S, MASU_S, MASU_S);
      }
      // スタートを描く
      fill(0, 0, 255); // 青 
      rect(start_x*MASU_S, start_y*MASU_S, MASU_S, MASU_S);
      // ゴールを描く
      fill(255, 255, 0); // 黄 
      rect(goal_x*MASU_S, goal_y*MASU_S, MASU_S, MASU_S);
      // 現在地を描く
      fill(255, 126, 0); // オレンジ
      rect(genzai_x*MASU_S, genzai_y*MASU_S, MASU_S, MASU_S);      
    }
  }
}
// ランダムウォーク（適当に歩きまくる）でゴールを探す関数
int RandomWalk(){
  int x = genzai_x;
  int y = genzai_y;
  // ゴールを発見したかどうかをチェック
  if(x == goal_x && y == goal_y){
    isGoal = 1;
    return 2;
  }
  // 分岐や曲がり角があったら曲がるかも
  // 垂直方向に進んでいる場合
  if(vx == 0 && (meiro[y][x+1] != 1 
              || meiro[y][x-1] != 1)){
    vx = (int)random(-2, 2); // -1か1になる
    vy = 0;
  // 水平方向に進んでいる場合
  }else if(vy == 0 && (meiro[y+1][x] != 1 
                    || meiro[y-1][x] != 1)){
    vy = (int)random(-2, 2); // -1か1になる
    vx = 0;
  }
  // 壁に当たったら反転
  // 垂直方向に進んでいる場合
  if(vx == 0 && (meiro[y+1][x] == 1 
              || meiro[y-1][x] == 1)){
    vy = -vy; 
  // 水平方向に進んでいる場合
  }else if(vy == 0 && (meiro[y][x+1] == 1 
                    || meiro[y][x-1] == 1)){
    vx = -vx;  
  }
  // 壁ではなかったら
  if(meiro[y+vy][x+vx] != 1){
    genzai_x = x + vx; // 歩く
    genzai_y = y + vy; // 歩く
  }
  return 0;
}

void mouseDragged(){
  if(isGoal == 1){
    // ゴールしたときの処理
    print("GOAL !\n");
  }else{
    // ゴールしていなければ探索
    RandomWalk();
  }
}
// 描画関数 標準では1秒間に60回実行される
void draw(){
  meiro_egaku();
}
